Whamcloud - gitweb
b=1719
[fs/lustre-release.git] / lustre / tests / sanity.sh
1 #!/bin/bash
2 #
3 # Run select tests by setting ONLY, or as arguments to the script.
4 # Skip specific tests by setting EXCEPT.
5 #
6 # e.g. ONLY="22 23" or ONLY="`seq 32 39`" or EXCEPT="31"
7 set -e
8
9 ONLY=${ONLY:-"$*"}
10 # bug number for skipped test: 1979
11 ALWAYS_EXCEPT=${ALWAYS_EXCEPT:-"42b"}
12 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
13
14 [ "$ALWAYS_EXCEPT$EXCEPT" ] && echo "Skipping tests: $ALWAYS_EXCEPT $EXCEPT"
15
16 SRCDIR=`dirname $0`
17 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
18
19 TMP=${TMP:-/tmp}
20
21 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
22 CREATETEST=${CREATETEST:-createtest}
23 LFIND=${LFIND:-lfind}
24 LSTRIPE=${LSTRIPE:-lstripe}
25 LCTL=${LCTL:-lctl}
26 MCREATE=${MCREATE:-mcreate}
27 OPENFILE=${OPENFILE:-openfile}
28 OPENUNLINK=${OPENUNLINK:-openunlink}
29 TOEXCL=${TOEXCL:-toexcl}
30 TRUNCATE=${TRUNCATE:-truncate}
31 MUNLINK=${MUNLINK:-munlink}
32 SOCKETSERVER=${SOCKETSERVER:-socketserver}
33 SOCKETCLIENT=${SOCKETCLIENT:-socketclient}
34 IOPENTEST1=${IOPENTEST1:-iopentest1}
35 IOPENTEST2=${IOPENTEST2:-iopentest2}
36
37 if [ $UID -ne 0 ]; then
38         RUNAS_ID="$UID"
39         RUNAS=""
40 else
41         RUNAS_ID=${RUNAS_ID:-500}
42         RUNAS=${RUNAS:-"runas -u $RUNAS_ID"}
43 fi
44
45 export NAME=${NAME:-local}
46
47 SAVE_PWD=$PWD
48
49 clean() {
50         echo -n "cln.."
51         sh llmountcleanup.sh > /dev/null || exit 20
52         I_MOUNTED=no
53 }
54 CLEAN=${CLEAN:-clean}
55
56 start() {
57         echo -n "mnt.."
58         sh llrmount.sh > /dev/null || exit 10
59         I_MOUNTED=yes
60         echo "done"
61 }
62 START=${START:-start}
63
64 log() {
65         echo "$*"
66         lctl mark "$*" 2> /dev/null || true
67 }
68
69 run_one() {
70         if ! mount | grep -q $DIR; then
71                 $START
72         fi
73         log "== test $1: $2"
74         export TESTNAME=test_$1
75         test_$1 || error "test_$1: $?"
76         unset TESTNAME
77         pass
78         cd $SAVE_PWD
79         $CLEAN
80 }
81
82 build_test_filter() {
83         for O in $ONLY; do
84             eval ONLY_${O}=true
85         done
86         for E in $EXCEPT $ALWAYS_EXCEPT; do
87             eval EXCEPT_${E}=true
88         done
89 }
90
91 _basetest() {
92     echo $*
93 }
94
95 basetest() {
96     IFS=abcdefghijklmnopqrstuvwxyz _basetest $1
97 }
98
99 run_test() {
100          base=`basetest $1`
101          if [ "$ONLY" ]; then
102                  testname=ONLY_$1
103                  if [ ${!testname}x != x ]; then
104                         run_one $1 "$2"
105                         return $?
106                  fi
107                  testname=ONLY_$base
108                  if [ ${!testname}x != x ]; then
109                          run_one $1 "$2"
110                          return $?
111                  fi
112                  echo -n "."
113                  return 0
114         fi
115         testname=EXCEPT_$1
116         if [ ${!testname}x != x ]; then
117                  echo "skipping excluded test $1"
118                  return 0
119         fi
120         testname=EXCEPT_$base
121         if [ ${!testname}x != x ]; then
122                  echo "skipping excluded test $1 (base $base)"
123                  return 0
124         fi
125         run_one $1 "$2"
126         return $?
127 }
128
129 [ "$SANITYLOG" ] && rm -f $SANITYLOG || true
130
131 error() { 
132         log "FAIL: $@"
133         if [ "$SANITYLOG" ]; then
134                 echo "FAIL: $TESTNAME $@" >> $SANITYLOG
135         else
136                 exit 1
137         fi
138 }
139
140 pass() { 
141         echo PASS
142 }
143
144 MOUNT="`mount | awk '/^'$NAME' .* lustre_lite / { print $3 }'`"
145 if [ -z "$MOUNT" ]; then
146         sh llmount.sh
147         MOUNT="`mount | awk '/^'$NAME' .* lustre_lite / { print $3 }'`"
148         [ -z "$MOUNT" ] && error "NAME=$NAME not mounted"
149         I_MOUNTED=yes
150 fi
151
152 [ `echo $MOUNT | wc -w` -gt 1 ] && error "NAME=$NAME mounted more than once"
153
154 DIR=${DIR:-$MOUNT}
155 [ -z "`echo $DIR | grep $MOUNT`" ] && echo "$DIR not in $MOUNT" && exit 99
156
157 LOVNAME=`cat /proc/fs/lustre/llite/fs0/lov/common_name`
158 STRIPECOUNT=`cat /proc/fs/lustre/lov/$LOVNAME/numobd`
159
160 [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
161 [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
162 rm -rf $DIR/[Rdfs][1-9]*
163
164 build_test_filter
165
166 echo preparing for tests involving mounts
167 EXT2_DEV=${EXT2_DEV:-/tmp/SANITY.LOOP}
168 touch $EXT2_DEV
169 mke2fs -F $EXT2_DEV 1000 > /dev/null
170
171 test_0() {
172         touch $DIR/f
173         $CHECKSTAT -t file $DIR/f || error
174         rm $DIR/f
175         $CHECKSTAT -a $DIR/f || error
176 }
177 run_test 0 "touch .../f ; rm .../f ============================="
178
179 test_1a() {
180         mkdir $DIR/d1
181         mkdir $DIR/d1/d2
182         $CHECKSTAT -t dir $DIR/d1/d2 || error
183 }
184 run_test 1a "mkdir .../d1; mkdir .../d1/d2 ====================="
185
186 test_1b() {
187         rmdir $DIR/d1/d2
188         rmdir $DIR/d1
189         $CHECKSTAT -a $DIR/d1 || error
190 }
191 run_test 1b "rmdir .../d1/d2; rmdir .../d1 ====================="
192
193 test_2a() {
194         mkdir $DIR/d2
195         touch $DIR/d2/f
196         $CHECKSTAT -t file $DIR/d2/f || error
197 }
198 run_test 2a "mkdir .../d2; touch .../d2/f ======================"
199
200 test_2b() {
201         rm -r $DIR/d2
202         $CHECKSTAT -a $DIR/d2 || error
203 }
204 run_test 2b "rm -r .../d2; checkstat .../d2/f ======================"
205
206 test_3a() {
207         mkdir $DIR/d3
208         $CHECKSTAT -t dir $DIR/d3 || error
209 }
210 run_test 3a "mkdir .../d3 ======================================"
211
212 test_3b() {
213         if [ ! -d $DIR/d3 ]; then
214                 mkdir $DIR/d3
215         fi
216         touch $DIR/d3/f
217         $CHECKSTAT -t file $DIR/d3/f || error
218 }
219 run_test 3b "touch .../d3/f ===================================="
220
221 test_3c() {
222         rm -r $DIR/d3
223         $CHECKSTAT -a $DIR/d3 || error
224 }
225 run_test 3c "rm -r .../d3 ======================================"
226
227 test_4a() {
228         mkdir $DIR/d4
229         $CHECKSTAT -t dir $DIR/d4 || error
230 }
231 run_test 4a "mkdir .../d4 ======================================"
232
233 test_4b() {
234         if [ ! -d $DIR/d4 ]; then
235                 mkdir $DIR/d4
236         fi
237         mkdir $DIR/d4/d2
238         $CHECKSTAT -t dir $DIR/d4/d2 || error
239 }
240 run_test 4b "mkdir .../d4/d2 ==================================="
241
242 test_5() {
243         mkdir $DIR/d5
244         mkdir $DIR/d5/d2
245         chmod 0707 $DIR/d5/d2
246         $CHECKSTAT -t dir -p 0707 $DIR/d5/d2 || error
247 }
248 run_test 5 "mkdir .../d5 .../d5/d2; chmod .../d5/d2 ============"
249
250 test_6a() {
251         touch $DIR/f6a
252         chmod 0666 $DIR/f6a || error
253         $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/f6a || error
254 }
255 run_test 6a "touch .../f6a; chmod .../f6a ======================"
256
257 test_6b() {
258         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6b" && return
259         if [ ! -f $DIR/f6a ]; then
260                 touch $DIR/f6a
261                 chmod 0666 $DIR/f6a
262         fi
263         $RUNAS chmod 0444 $DIR/f6a && error
264         $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/f6a || error
265 }
266 run_test 6b "$RUNAS chmod .../f6a (should return error) =="
267
268 test_6c() {
269         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6c" && return
270         touch $DIR/f6c
271         chown $RUNAS_ID $DIR/f6c || error
272         $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/f6c || error
273 }
274 run_test 6c "touch .../f6c; chown .../f6c ======================"
275
276 test_6d() {
277         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6d" && return
278         if [ ! -f $DIR/f6c ]; then
279                 touch $DIR/f6c
280                 chown $RUNAS_ID $DIR/f6c
281         fi
282         $RUNAS chown $UID $DIR/f6c && error
283         $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/f6c || error
284 }
285 run_test 6d "$RUNAS chown .../f6c (should return error) =="
286
287 test_6e() {
288         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6e" && return
289         touch $DIR/f6e
290         chgrp $RUNAS_ID $DIR/f6e || error
291         $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/f6e || error
292 }
293 run_test 6e "touch .../f6e; chgrp .../f6e ======================"
294
295 test_6f() {
296         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6f" && return
297         if [ ! -f $DIR/f6e ]; then
298                 touch $DIR/f6e
299                 chgrp $RUNAS_ID $DIR/f6e
300         fi
301         $RUNAS chgrp $UID $DIR/f6e && error
302         $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/f6e || error
303 }
304 run_test 6f "$RUNAS chgrp .../f6e (should return error) =="
305
306 test_6g() {
307         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6g" && return
308         mkdir $DIR/d6g || error
309         chmod 777 $DIR/d6g || error
310         $RUNAS mkdir $DIR/d6g/d || error
311         chmod g+s $DIR/d6g/d || error
312         mkdir $DIR/d6g/d/subdir
313         $CHECKSTAT -g \#$RUNAS_ID $DIR/d6g/d/subdir || error
314 }
315 run_test 6g "Is new dir in sgid dir inheriting group?"
316
317 test_7a() {
318         mkdir $DIR/d7
319         $MCREATE $DIR/d7/f
320         chmod 0666 $DIR/d7/f
321         $CHECKSTAT -t file -p 0666 $DIR/d7/f || error
322 }
323 run_test 7a "mkdir .../d7; mcreate .../d7/f; chmod .../d7/f ===="
324
325 test_7b() {
326         if [ ! -d $DIR/d7 ]; then
327                 mkdir $DIR/d7
328         fi
329         $MCREATE $DIR/d7/f2
330         echo -n foo > $DIR/d7/f2
331         [ "`cat $DIR/d7/f2`" = "foo" ] || error
332         $CHECKSTAT -t file -s 3 $DIR/d7/f2 || error
333 }
334 run_test 7b "mkdir .../d7; mcreate d7/f2; echo foo > d7/f2 ====="
335
336 test_8() {
337         mkdir $DIR/d8
338         touch $DIR/d8/f
339         chmod 0666 $DIR/d8/f
340         $CHECKSTAT -t file -p 0666 $DIR/d8/f || error
341 }
342 run_test 8 "mkdir .../d8; touch .../d8/f; chmod .../d8/f ======="
343
344 test_9() {
345         mkdir $DIR/d9
346         mkdir $DIR/d9/d2
347         mkdir $DIR/d9/d2/d3
348         $CHECKSTAT -t dir $DIR/d9/d2/d3 || error
349 }
350 run_test 9 "mkdir .../d9 .../d9/d2 .../d9/d2/d3 ================"
351
352 test_10() {
353         mkdir $DIR/d10
354         mkdir $DIR/d10/d2
355         touch $DIR/d10/d2/f
356         $CHECKSTAT -t file $DIR/d10/d2/f || error
357 }
358 run_test 10 "mkdir .../d10 .../d10/d2; touch .../d10/d2/f ======"
359
360 test_11() {
361         mkdir $DIR/d11
362         mkdir $DIR/d11/d2
363         chmod 0666 $DIR/d11/d2
364         chmod 0705 $DIR/d11/d2
365         $CHECKSTAT -t dir -p 0705 $DIR/d11/d2 || error
366 }
367 run_test 11 "mkdir .../d11 d11/d2; chmod .../d11/d2 ============"
368
369 test_12() {
370         mkdir $DIR/d12
371         touch $DIR/d12/f
372         chmod 0666 $DIR/d12/f
373         chmod 0654 $DIR/d12/f
374         $CHECKSTAT -t file -p 0654 $DIR/d12/f || error
375 }
376 run_test 12 "touch .../d12/f; chmod .../d12/f .../d12/f ========"
377
378 test_13() {
379         mkdir $DIR/d13
380         dd if=/dev/zero of=$DIR/d13/f count=10
381         >  $DIR/d13/f
382         $CHECKSTAT -t file -s 0 $DIR/d13/f || error
383 }
384 run_test 13 "creat .../d13/f; dd .../d13/f; > .../d13/f ========"
385
386 test_14() {
387         mkdir $DIR/d14
388         touch $DIR/d14/f
389         rm $DIR/d14/f
390         $CHECKSTAT -a $DIR/d14/f || error
391 }
392 run_test 14 "touch .../d14/f; rm .../d14/f; rm .../d14/f ======="
393
394 test_15() {
395         mkdir $DIR/d15
396         touch $DIR/d15/f
397         mv $DIR/d15/f $DIR/d15/f2
398         $CHECKSTAT -t file $DIR/d15/f2 || error
399 }
400 run_test 15 "touch .../d15/f; mv .../d15/f .../d15/f2 =========="
401
402 test_16() {
403         mkdir $DIR/d16
404         touch $DIR/d16/f
405         rm -rf $DIR/d16/f
406         $CHECKSTAT -a $DIR/d16/f || error
407 }
408 run_test 16 "touch .../d16/f; rm -rf .../d16/f ================="
409
410 test_17a() {
411         mkdir $DIR/d17
412         touch $DIR/d17/f
413         ln -s $DIR/d17/f $DIR/d17/l-exist
414         ls -l $DIR/d17
415         $CHECKSTAT -l $DIR/d17/f $DIR/d17/l-exist || error
416         $CHECKSTAT -f -t f $DIR/d17/l-exist || error
417         rm -f $DIR/l-exist
418         $CHECKSTAT -a $DIR/l-exist || error
419 }
420 run_test 17a "symlinks: create, remove (real) =================="
421
422 test_17b() {
423         if [ ! -d $DIR/d17 ]; then
424                 mkdir $DIR/d17
425         fi
426         ln -s no-such-file $DIR/d17/l-dangle
427         ls -l $DIR/d17
428         $CHECKSTAT -l no-such-file $DIR/d17/l-dangle || error
429         $CHECKSTAT -fa $DIR/d17/l-dangle || error
430         rm -f $DIR/l-dangle
431         $CHECKSTAT -a $DIR/l-dangle || error
432 }
433 run_test 17b "symlinks: create, remove (dangling) =============="
434
435 test_18() {
436         touch $DIR/f
437         ls $DIR || error
438 }
439 run_test 18 "touch .../f ; ls ... =============================="
440
441 test_19a() {
442         touch $DIR/f19
443         ls -l $DIR
444         rm $DIR/f19
445         $CHECKSTAT -a $DIR/f19 || error
446 }
447 run_test 19a "touch .../f19 ; ls -l ... ; rm .../f19 ==========="
448
449 test_19b() {
450         ls -l $DIR/f19 && error || true
451 }
452 run_test 19b "ls -l .../f19 (should return error) =============="
453
454 test_19c() {
455         [ $RUNAS_ID -eq $UID ] && echo "skipping test 19c" && return
456         $RUNAS touch $DIR/f19 && error || true
457 }
458 run_test 19c "$RUNAS touch .../f19 (should return error) =="
459
460 test_19d() {
461         cat $DIR/f19 && error || true
462 }
463 run_test 19d "cat .../f19 (should return error) =============="
464
465 test_20() {
466         touch $DIR/f
467         rm $DIR/f
468         log "1 done"
469         touch $DIR/f
470         rm $DIR/f
471         log "2 done"
472         touch $DIR/f
473         rm $DIR/f
474         log "3 done"
475         $CHECKSTAT -a $DIR/f || error
476 }
477 run_test 20 "touch .../f ; ls -l ... ==========================="
478
479 test_21() {
480         mkdir $DIR/d21
481         [ -f $DIR/d21/dangle ] && rm -f $DIR/d21/dangle
482         ln -s dangle $DIR/d21/link
483         echo foo >> $DIR/d21/link
484         cat $DIR/d21/dangle
485         $CHECKSTAT -t link $DIR/d21/link || error
486         $CHECKSTAT -f -t file $DIR/d21/link || error
487 }
488 run_test 21 "write to dangling link ============================"
489
490 test_22() {
491         mkdir $DIR/d22
492         chown $RUNAS_ID $DIR/d22
493         # Tar gets pissy if it can't access $PWD *sigh*
494         (cd /tmp;
495         $RUNAS tar cf - /etc/hosts /etc/sysconfig/network | \
496         $RUNAS tar xfC - $DIR/d22)
497         ls -lR $DIR/d22/etc
498         $CHECKSTAT -t dir $DIR/d22/etc || error
499         $CHECKSTAT -u \#$RUNAS_ID $DIR/d22/etc || error
500 }
501 run_test 22 "unpack tar archive as non-root user ==============="
502
503 test_23() {
504         mkdir $DIR/d23
505         $TOEXCL $DIR/d23/f23
506         $TOEXCL -e $DIR/d23/f23 || error
507 }
508 run_test 23 "O_CREAT|O_EXCL in subdir =========================="
509
510 test_24a() {
511         echo '== rename sanity =============================================='
512         echo '-- same directory rename'
513         mkdir $DIR/R1
514         touch $DIR/R1/f
515         mv $DIR/R1/f $DIR/R1/g
516         $CHECKSTAT -t file $DIR/R1/g || error
517 }
518 run_test 24a "touch .../R1/f; rename .../R1/f .../R1/g ========="
519
520 test_24b() {
521         mkdir $DIR/R2
522         touch $DIR/R2/{f,g}
523         mv $DIR/R2/f $DIR/R2/g
524         $CHECKSTAT -a $DIR/R2/f || error
525         $CHECKSTAT -t file $DIR/R2/g || error
526 }
527 run_test 24b "touch .../R2/{f,g}; rename .../R2/f .../R2/g ====="
528
529 test_24c() {
530         mkdir $DIR/R3
531         mkdir $DIR/R3/f
532         mv $DIR/R3/f $DIR/R3/g
533         $CHECKSTAT -a $DIR/R3/f || error
534         $CHECKSTAT -t dir $DIR/R3/g || error
535 }
536 run_test 24c "mkdir .../R3/f; rename .../R3/f .../R3/g ========="
537
538 test_24d() {
539         mkdir $DIR/R4
540         mkdir $DIR/R4/{f,g}
541         perl -e "rename \"$DIR/R4/f\", \"$DIR/R4/g\";"
542         $CHECKSTAT -a $DIR/R4/f || error
543         $CHECKSTAT -t dir $DIR/R4/g || error
544 }
545 run_test 24d "mkdir .../R4/{f,g}; rename .../R4/f .../R4/g ====="
546
547 test_24e() {
548         echo '-- cross directory renames --' 
549         mkdir $DIR/R5{a,b}
550         touch $DIR/R5a/f
551         mv $DIR/R5a/f $DIR/R5b/g
552         $CHECKSTAT -a $DIR/R5a/f || error
553         $CHECKSTAT -t file $DIR/R5b/g || error
554 }
555 run_test 24e "touch .../R5a/f; rename .../R5a/f .../R5b/g ======"
556
557 test_24f() {
558         mkdir $DIR/R6{a,b}
559         touch $DIR/R6a/f $DIR/R6b/g
560         mv $DIR/R6a/f $DIR/R6b/g
561         $CHECKSTAT -a $DIR/R6a/f || error
562         $CHECKSTAT -t file $DIR/R6b/g || error
563 }
564 run_test 24f "touch .../R6a/f R6b/g; mv .../R6a/f .../R6b/g ===="
565
566 test_24g() {
567         mkdir $DIR/R7{a,b}
568         mkdir $DIR/R7a/d
569         mv $DIR/R7a/d $DIR/R7b/e
570         $CHECKSTAT -a $DIR/R7a/d || error
571         $CHECKSTAT -t dir $DIR/R7b/e || error
572 }
573 run_test 24g "mkdir .../R7a/d; rename .../R7a/d .../R5b/e ======"
574
575 test_24h() {
576         mkdir $DIR/R8{a,b}
577         mkdir $DIR/R8a/d $DIR/R8b/e
578         perl -e "rename \"$DIR/R8a/d\", \"$DIR/R8b/e\";"
579         $CHECKSTAT -a $DIR/R8a/d || error
580         $CHECKSTAT -t dir $DIR/R8b/e || error
581 }
582 run_test 24h "mkdir .../R8{a,b} R8a/{d,e}; mv .../R8a/d .../R8b/e"
583
584 test_24i() {
585         echo "-- rename error cases"
586         mkdir $DIR/R9
587         mkdir $DIR/R9/a
588         touch $DIR/R9/f
589         perl -e "rename \"$DIR/R9/f\", \"$DIR/R9/a\";"
590         $CHECKSTAT -t file $DIR/R9/f || error
591         $CHECKSTAT -t dir  $DIR/R9/a || error
592         $CHECKSTAT -a file $DIR/R9/a/f || error
593 }
594 run_test 24i "rename file to dir error: touch f ; mkdir a ; rename f a"
595
596 test_24j() {
597         mkdir $DIR/R10
598         perl -e "rename \"$DIR/R10/f\", \"$DIR/R10/g\"" 
599         $CHECKSTAT -t dir $DIR/R10 || error
600         $CHECKSTAT -a $DIR/R10/f || error
601         $CHECKSTAT -a $DIR/R10/g || error
602 }
603 run_test 24j "source does not exist ============================" 
604
605 test_24k() {
606         mkdir $DIR/R11a $DIR/R11a/d
607         touch $DIR/R11a/f
608         mv $DIR/R11a/f $DIR/R11a/d
609         $CHECKSTAT -a $DIR/R11a/f || error
610         $CHECKSTAT -t file $DIR/R11a/d/f || error
611 }
612 run_test 24k "touch .../R11a/f; mv .../R11a/f .../R11a/d ======="
613
614 test_25a() {
615         echo '== symlink sanity ============================================='
616         mkdir $DIR/d25
617         ln -s d25 $DIR/s25
618         touch $DIR/s25/foo || error
619 }
620 run_test 25a "create file in symlinked directory ==============="
621
622 test_25b() {
623         if [ ! -d $DIR/d25 ]; then
624                 run_one 25a
625         fi
626         $CHECKSTAT -t file $DIR/s25/foo || error
627 }
628 run_test 25b "lookup file in symlinked directory ==============="
629
630 test_26a() {
631         mkdir $DIR/d26
632         mkdir $DIR/d26/d26-2
633         ln -s d26/d26-2 $DIR/s26
634         touch $DIR/s26/foo || error
635 }
636 run_test 26a "multiple component symlink ======================="
637
638 test_26b() {
639         mkdir -p $DIR/d26b/d26-2
640         ln -s d26b/d26-2/foo $DIR/s26-2
641         touch $DIR/s26-2 || error
642 }
643 run_test 26b "multiple component symlink at end of lookup ======"
644
645 test_26c() {
646         mkdir $DIR/d26.2
647         touch $DIR/d26.2/foo
648         ln -s d26.2 $DIR/s26.2-1
649         ln -s s26.2-1 $DIR/s26.2-2
650         ln -s s26.2-2 $DIR/s26.2-3
651         chmod 0666 $DIR/s26.2-3/foo
652 }
653 run_test 26c "chain of symlinks ================================"
654
655 # recursive symlinks (bug 439)
656 test_26d() {
657         ln -s d26-3/foo $DIR/d26-3
658 }
659 run_test 26d "create multiple component recursive symlink ======"
660
661 test_26e() {
662         if [ ! -h $DIR/d26-3 ]; then
663                 run_one 26d
664         fi
665         rm $DIR/d26-3
666 }
667 run_test 26e "unlink multiple component recursive symlink ======"
668
669 test_27a() {
670         echo '== stripe sanity =============================================='
671         mkdir $DIR/d27
672         $LSTRIPE $DIR/d27/f0 8192 0 1 || error
673         $CHECKSTAT -t file $DIR/d27/f0 || error
674         pass
675         log "== test_27b: write to one stripe file ========================="
676         cp /etc/hosts $DIR/d27/f0 || error
677 }
678 run_test 27a "one stripe file =================================="
679
680 test_27c() {
681         [ "$STRIPECOUNT" -lt "2" ] && echo "skipping 2-stripe test" && return
682         if [ ! -d $DIR/d27 ]; then
683                 mkdir $DIR/d27
684         fi
685         $LSTRIPE $DIR/d27/f01 8192 0 2 || error
686         [ `$LFIND $DIR/d27/f01 | grep -A 10 obdidx | wc -l` -eq 4 ] ||
687                 error "two-stripe file doesn't have two stripes"
688         pass
689         log "== test_27d: write to two stripe file file f01 ================"
690         dd if=/dev/zero of=$DIR/d27/f01 bs=4k count=4 || error
691 }
692 run_test 27c "create two stripe file f01 ======================="
693
694 test_27d() {
695         if [ ! -d $DIR/d27 ]; then
696                 mkdir $DIR/d27
697         fi
698         $LSTRIPE $DIR/d27/fdef 0 -1 0 || error
699         $CHECKSTAT -t file $DIR/d27/fdef || error
700         #dd if=/dev/zero of=$DIR/d27/fdef bs=4k count=4 || error
701 }
702 run_test 27d "create file with default settings ================"
703
704 test_27e() {
705         if [ ! -d $DIR/d27 ]; then
706                 mkdir $DIR/d27
707         fi
708         $LSTRIPE $DIR/d27/f12 8192 0 2 || error
709         $LSTRIPE $DIR/d27/f12 8192 0 2 && error
710         $CHECKSTAT -t file $DIR/d27/f12 || error
711 }
712 run_test 27e "lstripe existing file (should return error) ======"
713
714 test_27f() {
715         if [ ! -d $DIR/d27 ]; then
716                 mkdir $DIR/d27
717         fi
718         $LSTRIPE $DIR/d27/fbad 100 0 1 && error
719         dd if=/dev/zero of=$DIR/d27/f12 bs=4k count=4 || error
720         $LFIND $DIR/d27/fbad || error
721 }
722 run_test 27f "lstripe with bad stripe size (should return error)"
723
724 test_27g() {
725         if [ ! -d $DIR/d27 ]; then
726                 mkdir $DIR/d27
727         fi
728         $MCREATE $DIR/d27/fnone || error
729         pass
730         log "== test 27h: lfind with no objects ============================"
731         $LFIND $DIR/d27/fnone 2>&1 | grep -q "no stripe info" || error
732         pass
733         log "== test 27i: lfind with some objects =========================="
734         touch $DIR/d27/fsome || error
735         $LFIND $DIR/d27/fsome | grep -q obdidx || error
736 }
737 run_test 27g "test lfind ======================================="
738
739 test_27j() {
740         if [ ! -d $DIR/d27 ]; then
741                 mkdir $DIR/d27
742         fi
743         $LSTRIPE $DIR/d27/f27j 8192 $STRIPECOUNT 1 && error || true
744 }
745 run_test 27j "lstripe with bad stripe offset (should return error)"
746
747 test_28() {
748         mkdir $DIR/d28
749         $CREATETEST $DIR/d28/ct || error
750 }
751 run_test 28 "create/mknod/mkdir with bad file types ============"
752
753 cancel_lru_locks() {
754         for d in /proc/fs/lustre/ldlm/namespaces/$1*; do
755                 echo clear > $d/lru_size
756         done
757         grep [0-9] /proc/fs/lustre/ldlm/namespaces/$1*/lock_unused_count /dev/null
758 }
759
760 test_29() {
761         cancel_lru_locks MDC
762         mkdir $DIR/d29
763         touch $DIR/d29/foo
764         log 'first d29'
765         ls -l $DIR/d29
766         MDCDIR=${MDCDIR:-/proc/fs/lustre/ldlm/namespaces/MDC_*}
767         LOCKCOUNTORIG=`cat $MDCDIR/lock_count`
768         LOCKUNUSEDCOUNTORIG=`cat $MDCDIR/lock_unused_count`
769         log 'second d29'
770         ls -l $DIR/d29
771         log 'done'
772         LOCKCOUNTCURRENT=`cat $MDCDIR/lock_count`
773         LOCKUNUSEDCOUNTCURRENT=`cat $MDCDIR/lock_unused_count`
774         if [ $LOCKCOUNTCURRENT -gt $LOCKCOUNTORIG ]; then
775                 echo "CURRENT: $LOCKCOUNTCURRENT > $LOCKCOUNTORIG"
776                 error
777         fi
778         if [ $LOCKUNUSEDCOUNTCURRENT -gt $LOCKUNUSEDCOUNTORIG ]; then
779                 echo "UNUSED: $LOCKUNUSEDCOUNTCURRENT > $LOCKUNUSEDCOUNTORIG"
780                 error
781         fi
782 }
783 run_test 29 "IT_GETATTR regression  ============================"
784
785 test_30() {
786         cp `which ls` $DIR
787         $DIR/ls /
788         rm $DIR/ls
789 }
790 run_test 30 "run binary from Lustre (execve) ==================="
791
792 test_31a() {
793         $OPENUNLINK $DIR/f31 $DIR/f31 || error
794         $CHECKSTAT -a $DIR/f31 || error
795 }
796 run_test 31a "open-unlink file =================================="
797
798 test_31b() {
799         touch $DIR/f31 || error
800         ln $DIR/f31 $DIR/f31b || error
801         multiop $DIR/f31b Ouc || error
802         $CHECKSTAT -t file $DIR/f31 || error
803 }
804 run_test 31b "unlink file with multiple links while open ======="
805
806 test_31c() {
807         touch $DIR/f31 || error
808         ln $DIR/f31 $DIR/f31c || error
809         multiop $DIR/f31 O_uc &
810         MULTIPID=$!
811         multiop $DIR/f31c Ouc
812         usleep 500
813         kill -USR1 $MULTIPID
814         wait $MUTLIPID
815 }
816 run_test 31c "open-unlink file with multiple links ============="
817
818 test_31d() {
819         opendirunlink $DIR/d31d $DIR/d31d || error
820         $CHECKSTAT -a $DIR/d31d || error
821 }
822 run_test 31d "remove of open directory ========================="
823
824 test_32a() {
825         echo "== more mountpoints and symlinks ================="
826         [ -e $DIR/d32a ] && rm -fr $DIR/d32a
827         mkdir -p $DIR/d32a/ext2-mountpoint 
828         mount -t ext2 -o loop $EXT2_DEV $DIR/d32a/ext2-mountpoint || error
829         $CHECKSTAT -t dir $DIR/d32a/ext2-mountpoint/.. || error  
830         umount $DIR/d32a/ext2-mountpoint || error
831 }
832 run_test 32a "stat d32a/ext2-mountpoint/.. ====================="
833
834 test_32b() {
835         [ -e $DIR/d32b ] && rm -fr $DIR/d32b
836         mkdir -p $DIR/d32b/ext2-mountpoint 
837         mount -t ext2 -o loop $EXT2_DEV $DIR/d32b/ext2-mountpoint || error
838         ls -al $DIR/d32b/ext2-mountpoint/.. || error
839         umount $DIR/d32b/ext2-mountpoint || error
840 }
841 run_test 32b "open d32b/ext2-mountpoint/.. ====================="
842  
843 test_32c() {
844         [ -e $DIR/d32c ] && rm -fr $DIR/d32c
845         mkdir -p $DIR/d32c/ext2-mountpoint 
846         mount -t ext2 -o loop $EXT2_DEV $DIR/d32c/ext2-mountpoint || error
847         mkdir -p $DIR/d32c/d2/test_dir    
848         $CHECKSTAT -t dir $DIR/d32c/ext2-mountpoint/../d2/test_dir || error
849         umount $DIR/d32c/ext2-mountpoint || error
850 }
851 run_test 32c "stat d32c/ext2-mountpoint/../d2/test_dir ========="
852
853 test_32d() {
854         [ -e $DIR/d32d ] && rm -fr $DIR/d32d
855         mkdir -p $DIR/d32d/ext2-mountpoint 
856         mount -t ext2 -o loop $EXT2_DEV $DIR/d32d/ext2-mountpoint || error
857         mkdir -p $DIR/d32d/d2/test_dir    
858         ls -al $DIR/d32d/ext2-mountpoint/../d2/test_dir || error
859         umount $DIR/d32d/ext2-mountpoint || error
860 }
861 run_test 32d "open d32d/ext2-mountpoint/../d2/test_dir ========="
862
863 test_32e() {
864         [ -e $DIR/d32e ] && rm -fr $DIR/d32e
865         mkdir -p $DIR/d32e/tmp    
866         TMP_DIR=$DIR/d32e/tmp       
867         ln -s $DIR/d32e $TMP_DIR/symlink11 
868         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
869         $CHECKSTAT -t link $DIR/d32e/tmp/symlink11 || error
870         $CHECKSTAT -t link $DIR/d32e/symlink01 || error
871 }
872 run_test 32e "stat d32e/symlink->tmp/symlink->lustre-subdir ===="
873
874 test_32f() {
875         [ -e $DIR/d32f ] && rm -fr $DIR/d32f
876         mkdir -p $DIR/d32f/tmp    
877         TMP_DIR=$DIR/d32f/tmp       
878         ln -s $DIR/d32f $TMP_DIR/symlink11 
879         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
880         ls $DIR/d32f/tmp/symlink11  || error
881         ls $DIR/d32f/symlink01 || error
882 }
883 run_test 32f "open d32f/symlink->tmp/symlink->lustre-subdir ===="
884
885 test_32g() {
886         [ -e $DIR/d32g ] && rm -fr $DIR/d32g
887         [ -e $DIR/test_dir ] && rm -fr $DIR/test_dir
888         mkdir -p $DIR/test_dir 
889         mkdir -p $DIR/d32g/tmp    
890         TMP_DIR=$DIR/d32g/tmp       
891         ln -s $DIR/test_dir $TMP_DIR/symlink12 
892         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
893         $CHECKSTAT -t link $DIR/d32g/tmp/symlink12 || error
894         $CHECKSTAT -t link $DIR/d32g/symlink02 || error
895         $CHECKSTAT -t dir -f $DIR/d32g/tmp/symlink12 || error
896         $CHECKSTAT -t dir -f $DIR/d32g/symlink02 || error
897 }
898 run_test 32g "stat d32g/symlink->tmp/symlink->lustre-subdir/test_dir"
899
900 test_32h() {
901         [ -e $DIR/d32h ] && rm -fr $DIR/d32h
902         [ -e $DIR/test_dir ] && rm -fr $DIR/test_dir
903         mkdir -p $DIR/test_dir 
904         mkdir -p $DIR/d32h/tmp    
905         TMP_DIR=$DIR/d32h/tmp       
906         ln -s $DIR/test_dir $TMP_DIR/symlink12 
907         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
908         ls $DIR/d32h/tmp/symlink12 || error
909         ls $DIR/d32h/symlink02  || error
910 }
911 run_test 32h "open d32h/symlink->tmp/symlink->lustre-subdir/test_dir"
912
913 test_32i() {
914         [ -e $DIR/d32i ] && rm -fr $DIR/d32i
915         mkdir -p $DIR/d32i/ext2-mountpoint 
916         mount -t ext2 -o loop $EXT2_DEV $DIR/d32i/ext2-mountpoint || error
917         touch $DIR/d32i/test_file
918         $CHECKSTAT -t file $DIR/d32i/ext2-mountpoint/../test_file || error  
919         umount $DIR/d32i/ext2-mountpoint || error
920 }
921 run_test 32i "stat d32i/ext2-mountpoint/../test_file ==========="
922
923 test_32j() {
924         [ -e $DIR/d32j ] && rm -fr $DIR/d32j
925         mkdir -p $DIR/d32j/ext2-mountpoint 
926         mount -t ext2 -o loop $EXT2_DEV $DIR/d32j/ext2-mountpoint || error
927         touch $DIR/d32j/test_file
928         cat $DIR/d32j/ext2-mountpoint/../test_file || error
929         umount $DIR/d32j/ext2-mountpoint || error
930 }
931 run_test 32j "open d32j/ext2-mountpoint/../test_file ==========="
932
933 test_32k() {
934         rm -fr $DIR/d32k
935         mkdir -p $DIR/d32k/ext2-mountpoint 
936         mount -t ext2 -o loop $EXT2_DEV $DIR/d32k/ext2-mountpoint  
937         mkdir -p $DIR/d32k/d2
938         touch $DIR/d32k/d2/test_file || error
939         $CHECKSTAT -t file $DIR/d32k/ext2-mountpoint/../d2/test_file || error
940         umount $DIR/d32k/ext2-mountpoint || error
941 }
942 run_test 32k "stat d32k/ext2-mountpoint/../d2/test_file ========"
943
944 test_32l() {
945         rm -fr $DIR/d32l
946         mkdir -p $DIR/d32l/ext2-mountpoint 
947         mount -t ext2 -o loop $EXT2_DEV $DIR/d32l/ext2-mountpoint || error
948         mkdir -p $DIR/d32l/d2
949         touch $DIR/d32l/d2/test_file
950         cat  $DIR/d32l/ext2-mountpoint/../d2/test_file || error
951         umount $DIR/d32l/ext2-mountpoint || error
952 }
953 run_test 32l "open d32l/ext2-mountpoint/../d2/test_file ========"
954
955 test_32m() {
956         rm -fr $DIR/d32m
957         mkdir -p $DIR/d32m/tmp    
958         TMP_DIR=$DIR/d32m/tmp       
959         ln -s $DIR $TMP_DIR/symlink11 
960         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
961         $CHECKSTAT -t link $DIR/d32m/tmp/symlink11 || error
962         $CHECKSTAT -t link $DIR/d32m/symlink01 || error
963 }
964 run_test 32m "stat d32m/symlink->tmp/symlink->lustre-root ======"
965
966 test_32n() {
967         rm -fr $DIR/d32n
968         mkdir -p $DIR/d32n/tmp    
969         TMP_DIR=$DIR/d32n/tmp       
970         ln -s $DIR $TMP_DIR/symlink11 
971         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
972         ls -l $DIR/d32n/tmp/symlink11  || error
973         ls -l $DIR/d32n/symlink01 || error
974 }
975 run_test 32n "open d32n/symlink->tmp/symlink->lustre-root ======"
976
977 test_32o() {
978         rm -fr $DIR/d32o
979         rm -f $DIR/test_file
980         touch $DIR/test_file 
981         mkdir -p $DIR/d32o/tmp    
982         TMP_DIR=$DIR/d32o/tmp       
983         ln -s $DIR/test_file $TMP_DIR/symlink12 
984         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
985         $CHECKSTAT -t link $DIR/d32o/tmp/symlink12 || error
986         $CHECKSTAT -t link $DIR/d32o/symlink02 || error
987         $CHECKSTAT -t file -f $DIR/d32o/tmp/symlink12 || error
988         $CHECKSTAT -t file -f $DIR/d32o/symlink02 || error
989 }
990 run_test 32o "stat d32o/symlink->tmp/symlink->lustre-root/test_file"
991
992 test_32p() {
993     log 32p_1
994         rm -fr $DIR/d32p
995     log 32p_2
996         rm -f $DIR/test_file
997     log 32p_3
998         touch $DIR/test_file 
999     log 32p_4
1000         mkdir -p $DIR/d32p/tmp    
1001     log 32p_5
1002         TMP_DIR=$DIR/d32p/tmp       
1003     log 32p_6
1004         ln -s $DIR/test_file $TMP_DIR/symlink12 
1005     log 32p_7
1006         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
1007     log 32p_8
1008         cat $DIR/d32p/tmp/symlink12 || error
1009     log 32p_9
1010         cat $DIR/d32p/symlink02 || error
1011     log 32p_10
1012 }
1013 run_test 32p "open d32p/symlink->tmp/symlink->lustre-root/test_file"
1014
1015 test_32q() {
1016         [ -e $DIR/d32q ] && rm -fr $DIR/d32q
1017         mkdir -p $DIR/d32q
1018         touch $DIR/d32q/under_the_mount
1019         mount -t ext2 -o loop $EXT2_DEV $DIR/d32q
1020         ls $DIR/d32q/under_the_mount &&  error || true
1021         umount $DIR/d32q || error
1022 }
1023 run_test 32q "stat follows mountpoints in Lustre ========================="
1024
1025 test_32r() {
1026         [ -e $DIR/d32r ] && rm -fr $DIR/d32r
1027         mkdir -p $DIR/d32r
1028         touch $DIR/d32r/under_the_mount
1029         mount -t ext2 -o loop $EXT2_DEV $DIR/d32r
1030         ls $DIR/d32r | grep -q under_the_mount &&  error || true
1031         umount $DIR/d32r || error
1032 }
1033 run_test 32r "opendir follows mountpoints in Lustre ========================="
1034
1035 #   chmod 444 /mnt/lustre/somefile
1036 #   open(/mnt/lustre/somefile, O_RDWR)
1037 #   Should return -1
1038 test_33() {
1039         rm -f $DIR/test_33_file
1040         touch $DIR/test_33_file
1041         chmod 444 $DIR/test_33_file
1042         chown $RUNAS_ID $DIR/test_33_file
1043         log 33_1
1044         $RUNAS $OPENFILE -f O_RDWR $DIR/test_33_file && error || true
1045         log 33_2
1046 }
1047 run_test 33 "write file with mode 444 (should return error) ===="
1048
1049 TEST_34_SIZE=${TEST_34_SIZE:-2000000000000}
1050 test_34a() {
1051         rm -f $DIR/test_34_file
1052         $MCREATE $DIR/test_34_file || error
1053         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1054         $TRUNCATE $DIR/test_34_file $TEST_34_SIZE || error
1055         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1056         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1057 }
1058 run_test 34a "truncate file that has not been opened ==========="
1059
1060 test_34b() {
1061         [ ! -f $DIR/test_34_file ] && run_one 34a
1062         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1063         $OPENFILE -f O_RDONLY $DIR/test_34_file
1064         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1065         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1066 }
1067 run_test 34b "O_RDONLY opening file doesn't create objects ====="
1068
1069 test_34c() {
1070         [ ! -f $DIR/test_34_file ] && run_one 34a 
1071         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1072         $OPENFILE -f O_RDWR $DIR/test_34_file
1073         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" && error
1074         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1075 }
1076 run_test 34c "O_RDWR opening file-with-size works =============="
1077
1078 test_34d() {
1079         dd if=/dev/zero of=$DIR/test_34_file conv=notrunc bs=4k count=1 || error
1080         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1081         rm $DIR/test_34_file
1082 }
1083 run_test 34d "write to sparse file ============================="
1084
1085 test_34e() {
1086         rm -f $DIR/test_34_file
1087         $MCREATE $DIR/test_34_file || error
1088         $TRUNCATE $DIR/test_34_file 1000 || error
1089         $CHECKSTAT -s 1000 $DIR/test_34_file || error
1090         $OPENFILE -f O_RDWR $DIR/test_34_file
1091         $CHECKSTAT -s 1000 $DIR/test_34_file || error
1092 }
1093 run_test 34e "create objects, some with size and some without =="
1094
1095 test_35a() {
1096         cp /bin/sh $DIR/test_35a_file
1097         chmod 444 $DIR/test_35a_file
1098         chown $RUNAS_ID $DIR/test_35a_file
1099         $RUNAS $DIR/test_35a_file && error || true
1100         rm $DIR/test_35a_file
1101 }
1102 run_test 35a "exec file with mode 444 (should return and not leak) ====="
1103
1104
1105 test_36a() {
1106         rm -f $DIR/test_36_file
1107         utime $DIR/test_36_file || error
1108 }
1109 run_test 36a "MDS utime check (mknod, utime) ==================="
1110
1111 test_36b() {
1112         echo "" > $DIR/test_36_file
1113         utime $DIR/test_36_file || error
1114 }
1115 run_test 36b "OST utime check (open, utime) ===================="
1116
1117 test_36c() {
1118         rm -f $DIR/d36/test_36_file
1119         mkdir $DIR/d36
1120         chown $RUNAS_ID $DIR/d36
1121         $RUNAS utime $DIR/d36/test_36_file || error
1122 }
1123 run_test 36c "non-root MDS utime check (mknod, utime) =========="
1124
1125 test_36d() {
1126         [ ! -d $DIR/d36 ] && run_one 36c
1127         echo "" > $DIR/d36/test_36_file
1128         $RUNAS utime $DIR/d36/test_36_file || error
1129 }
1130 run_test 36d "non-root OST utime check (open, utime) ==========="
1131
1132 test_36e() {
1133         [ $RUNAS_ID -eq $UID ] && return
1134         [ ! -d $DIR/d36 ] && mkdir $DIR/d36
1135         touch $DIR/d36/test_36_file2
1136         $RUNAS utime $DIR/d36/test_36_file2 && error || true
1137 }
1138 run_test 36e "utime on non-owned file (should return error) ===="
1139
1140 test_37() {
1141         mkdir -p $DIR/dextra
1142         echo f > $DIR/dextra/fbugfile
1143         mount -t ext2 -o loop $EXT2_DEV $DIR/dextra
1144         ls $DIR/dextra | grep "\<fbugfile\>" && error
1145         umount $DIR/dextra || error
1146         rm -f $DIR/dextra/fbugfile || error
1147 }
1148 run_test 37 "ls a mounted file system to check old content ====="
1149
1150 test_38() {
1151         o_directory $DIR/test38
1152 }
1153 run_test 38 "open a regular file with O_DIRECTORY =============="
1154
1155 test_39() {
1156         touch $DIR/test_39_file
1157         touch $DIR/test_39_file2
1158 #       ls -l  $DIR/test_39_file $DIR/test_39_file2
1159 #       ls -lu  $DIR/test_39_file $DIR/test_39_file2
1160 #       ls -lc  $DIR/test_39_file $DIR/test_39_file2
1161         sleep 2
1162         $OPENFILE -f O_CREAT:O_TRUNC:O_WRONLY $DIR/test_39_file2
1163 #       ls -l  $DIR/test_39_file $DIR/test_39_file2
1164 #       ls -lu  $DIR/test_39_file $DIR/test_39_file2
1165 #       ls -lc  $DIR/test_39_file $DIR/test_39_file2
1166         [ $DIR/test_39_file2 -nt $DIR/test_39_file ] || error
1167 }
1168 run_test 39 "mtime changed on create ==========================="
1169
1170 test_40() {
1171         dd if=/dev/zero of=$DIR/f40 bs=4096 count=1
1172         $RUNAS $OPENFILE -f O_WRONLY:O_TRUNC $DIR/f40 && error
1173         $CHECKSTAT -t file -s 4096 $DIR/f40 || error
1174 }
1175 run_test 40 "failed open(O_TRUNC) doesn't truncate ============="
1176
1177 test_41() {
1178         # bug 1553
1179         small_write $DIR/f41 18
1180 }
1181 run_test 41 "test small file write + fstat ====================="
1182
1183 count_ost_writes() {
1184         cat /proc/fs/lustre/osc/*/stats |
1185             awk -vwrites=0 '/ost_write/ { writes += $2 } END { print writes; }'
1186 }
1187 start_kupdated() {
1188         # in 2.6, restore /proc/sys/vm/dirty_writeback_centisecs
1189         kill -CONT `pidof kupdated`
1190 }
1191 stop_kupdated() {
1192         # in 2.6, save and 0 /proc/sys/vm/dirty_writeback_centisecs
1193         kill -STOP `pidof kupdated`
1194         trap start_kupdated EXIT
1195 }
1196
1197 # Tests 42* verify that our behaviour is correct WRT caching, file closure,
1198 # file truncation, and file removal.
1199 test_42a() {
1200         cancel_lru_locks OSC
1201         stop_kupdated
1202         sync # just to be safe
1203         BEFOREWRITES=`count_ost_writes`
1204         dd if=/dev/zero of=$DIR/f42a bs=1024 count=100
1205         AFTERWRITES=`count_ost_writes`
1206         [ $BEFOREWRITES -eq $AFTERWRITES ] || \
1207                 error "$BEFOREWRITES < $AFTERWRITES"
1208         start_kupdated
1209 }
1210 run_test 42a "ensure that we don't flush on close =============="
1211
1212 test_42b() {
1213         cancel_lru_locks OSC
1214         stop_kupdated
1215         sync
1216         dd if=/dev/zero of=$DIR/f42b bs=1024 count=100
1217         BEFOREWRITES=`count_ost_writes`
1218         $MUNLINK $DIR/f42b || error "$MUNLINK $DIR/f42b: $?"
1219         AFTERWRITES=`count_ost_writes`
1220         [ $BEFOREWRITES -eq $AFTERWRITES ] ||
1221             error "$BEFOREWRITES < $AFTERWRITES on unlink"
1222         BEFOREWRITES=`count_ost_writes`
1223         sync || error "sync: $?"
1224         AFTERWRITES=`count_ost_writes`
1225         [ $BEFOREWRITES -eq $AFTERWRITES ] ||
1226             error "$BEFOREWRITES < $AFTERWRITES on sync"
1227         dmesg | grep 'error from obd_brw_async' && error 'error writing back'
1228         start_kupdated
1229         return 0
1230 }
1231 run_test 42b "test destroy of file with cached dirty data ======"
1232
1233 # if these tests just want to test the effect of truncation,
1234 # they have to be very careful.  consider:
1235 # - the first open gets a {0,EOF}PR lock
1236 # - the first write conflicts and gets a {0, count-1}PW
1237 # - the rest of the writes are under {count,EOF}PW
1238 # - the open for truncate tries to match a {0,EOF}PR
1239 #   for the filesize and cancels the PWs.
1240 # any number of fixes (don't get {0,EOF} on open, match
1241 # composite locks, do smarter file size management) fix
1242 # this, but for now we want these tests to verify that
1243 # the cancelation with truncate intent works, so we
1244 # start the file with a full-file pw lock to match against
1245 # until the truncate.
1246 trunc_test() {
1247         test=$1
1248         file=$DIR/$test
1249         offset=$2
1250         cancel_lru_locks OSC
1251         stop_kupdated
1252         # prime the file with 0,EOF PW to match
1253         touch $file
1254         $TRUNCATE $file 0
1255         sync; sync
1256         # now the real test..
1257         dd if=/dev/zero of=$file bs=1024 count=100
1258         BEFOREWRITES=`count_ost_writes`
1259         $TRUNCATE $file $offset
1260         cancel_lru_locks OSC
1261         AFTERWRITES=`count_ost_writes`
1262         start_kupdated
1263 }
1264
1265 test_42c() {
1266         trunc_test 42c 1024
1267         [ $BEFOREWRITES -eq $AFTERWRITES ] && \
1268             error "$BEFOREWRITES < $AFTERWRITES on truncate"
1269         rm $file
1270 }
1271 run_test 42c "test partial truncate of file with cached dirty data ===="
1272
1273 test_42d() {
1274         trunc_test 42d 0
1275         [ $BEFOREWRITES -eq $AFTERWRITES ] || \
1276             error "beforewrites $BEFOREWRITES != afterwrites $AFTERWRITES on truncate"
1277         rm $file
1278 }
1279 run_test 42d "test complete truncate of file with cached dirty data ===="
1280
1281 test_43() {
1282         mkdir $DIR/d43
1283         cp -p /bin/ls $DIR/d43/f
1284         exec 100>> $DIR/d43/f   
1285         $DIR/d43/f && error || true
1286         exec 100<&-
1287 }
1288 run_test 43 "execution of file opened for write should return -ETXTBSY=="
1289
1290 test_43a() {
1291         mkdir -p $DIR/d43
1292         cp -p `which multiop` $DIR/d43/multiop
1293         touch $DIR/d43/g
1294         $DIR/d43/multiop $DIR/d43/g o_c &
1295         MULTIPID=$!
1296         sleep 1
1297         multiop $DIR/d43/multiop Oc && error "expected error, got success"
1298         kill -USR1 $MULTIPID || return 2
1299         wait $MULTIPID || return 3
1300 }
1301 run_test 43a "open(RDWR) of file being executed should return -ETXTBSY=="
1302
1303 test_43b() {
1304         mkdir -p $DIR/d43
1305         cp -p `which multiop` $DIR/d43/multiop
1306         touch $DIR/d43/g
1307         $DIR/d43/multiop $DIR/d43/g o_c &
1308         MULTIPID=$!
1309         sleep 1
1310         truncate $DIR/d43/multiop 0 && error "expected error, got success"
1311         kill -USR1 $MULTIPID || return 2
1312         wait $MULTIPID || return 3
1313 }
1314 run_test 43b "truncate of file being executed should return -ETXTBSY===="
1315
1316 test_43c() {
1317         local testdir="$DIR/d43c"
1318         mkdir -p $testdir
1319         cp $SHELL $testdir/
1320         ( cd $(dirname $SHELL) && md5sum $(basename $SHELL) ) |  \
1321                 ( cd $testdir && md5sum -c)
1322 }
1323 run_test 43c "md5sum of copy into lustre================================"
1324
1325 test_44() {
1326         [  "$STRIPECOUNT" -lt "2" ] && echo "skipping 2-stripe test" && return
1327         dd if=/dev/zero of=$DIR/f1 bs=4k count=1 seek=127
1328         dd if=$DIR/f1 bs=4k count=1
1329 }
1330 run_test 44 "zero length read from a sparse stripe ============="
1331
1332 test_44a() {
1333     local nstripe=`$LCTL lov_getconfig $DIR | grep default_stripe_count: | \
1334                          awk '{print $2}'`
1335     local stride=`$LCTL lov_getconfig $DIR | grep default_stripe_size: | \
1336                       awk '{print $2}'`
1337     if [ $nstripe -eq 0 ] ; then
1338         nstripe=`$LCTL lov_getconfig $DIR | grep obd_count: | awk '{print $2}'`
1339     fi
1340
1341     OFFSETS="0 $((stride/2)) $((stride-1))"
1342     for offset in $OFFSETS ; do
1343       for i in `seq 0 $((nstripe-1))`; do
1344         rm -f $DIR/d44a
1345         local GLOBALOFFSETS=""
1346         local size=$((((i + 2 * $nstripe )*$stride + $offset)))  # Bytes
1347         ll_sparseness_write $DIR/d44a $size  || error "ll_sparseness_write"
1348         GLOBALOFFSETS="$GLOBALOFFSETS $size"
1349         ll_sparseness_verify $DIR/d44a $GLOBALOFFSETS \
1350                             || error "ll_sparseness_verify $GLOBALOFFSETS"
1351
1352         for j in `seq 0 $((nstripe-1))`; do
1353             size=$((((j + $nstripe )*$stride + $offset)))  # Bytes
1354             ll_sparseness_write $DIR/d44a $size || error "ll_sparseness_write"
1355             GLOBALOFFSETS="$GLOBALOFFSETS $size"
1356         done
1357         ll_sparseness_verify $DIR/d44a $GLOBALOFFSETS \
1358                             || error "ll_sparseness_verify $GLOBALOFFSETS"
1359       done
1360     done
1361 }
1362 run_test 44a "test sparse pwrite ==============================="
1363
1364 dirty_osc_total() {
1365         tot=0
1366         for d in /proc/fs/lustre/osc/*/cur_dirty_bytes; do
1367                 tot=$(($tot + `cat $d`))
1368         done
1369         echo $tot
1370 }
1371 do_dirty_record() {
1372         before=`dirty_osc_total`
1373         echo executing "\"$*\""
1374         eval $*
1375         after=`dirty_osc_total`
1376         echo before $before, after $after
1377 }
1378 test_45() {
1379         f="$DIR/f45"
1380         stop_kupdated
1381         sync
1382         do_dirty_record "echo blah > $f"
1383         [ $before -eq $after ] && error "write wasn't cached"
1384         do_dirty_record "> $f"
1385         [ $before -gt $after ] || error "truncate didn't lower dirty count"
1386         do_dirty_record "echo blah > $f"
1387         [ $before -eq $after ] && error "write wasn't cached"
1388         do_dirty_record "sync"
1389         [ $before -gt $after ] || error "writeback didn't lower dirty count"
1390         do_dirty_record "echo blah > $f"
1391         [ $before -eq $after ] && error "write wasn't cached"
1392         do_dirty_record "cancel_lru_locks OSC"
1393         [ $before -gt $after ] || error "lock cancelation didn't lower dirty count"
1394         start_kupdated
1395 }
1396 run_test 45 "osc io page accounting ============================"
1397
1398 page_size() {
1399         getconf PAGE_SIZE
1400 }
1401
1402 # in a 2 stripe file (lov.sh), page 63 maps to page 31 in its object.  this
1403 # test tickles a bug where re-dirtying a page was failing to be mapped to the
1404 # objects offset and an assert hit when an rpc was built with 63's mapped 
1405 # offset 31 and 31's raw 31 offset. it also found general redirtying bugs.
1406 test_46() {
1407         f="$DIR/f46"
1408         stop_kupdated
1409         sync
1410         dd if=/dev/zero of=$f bs=`page_size` seek=31 count=1
1411         sync
1412         dd conv=notrunc if=/dev/zero of=$f bs=`page_size` seek=63 count=1
1413         dd conv=notrunc if=/dev/zero of=$f bs=`page_size` seek=31 count=1
1414         sync
1415         start_kupdated
1416 }
1417 run_test 46 "dirtying a previously written page ================"
1418
1419 # Check that device nodes are created and then visible correctly (#2091)
1420 test_47() {
1421         cmknod $DIR/test_47_node || error
1422 }
1423 run_test 47 "Device nodes check ================================"
1424
1425 test_48() {
1426         mkdir $DIR/d48
1427         cd $DIR/d48
1428         mv $DIR/d48 $DIR/d48.new || error "move directory failed"
1429         mkdir $DIR/d48 || error "recreate diectory failed"
1430         ls || error "can't list after recreate directory"
1431 }
1432 run_test 48 "Access renamed current working directory ========="
1433
1434 test_50() {
1435         # bug 1485
1436         mkdir $DIR/d50
1437         cd $DIR/d50
1438         ls /proc/$$/cwd || error
1439 }
1440 run_test 50 "special situations: /proc symlinks  ==============="
1441
1442 test_51() {
1443         # bug 1516 - create an empty entry right after ".." then split dir
1444         mkdir $DIR/d49
1445         touch $DIR/d49/foo
1446         $MCREATE $DIR/d49/bar
1447         rm $DIR/d49/foo
1448         createmany -m $DIR/d49/longfile 201
1449         FNUM=202
1450         while [ `ls -sd $DIR/d49 | awk '{ print $1 }'` -eq 4 ]; do
1451                 $MCREATE $DIR/d49/longfile$FNUM
1452                 FNUM=$(($FNUM + 1))
1453                 echo -n "+"
1454         done
1455         ls -l $DIR/d49 > /dev/null || error
1456 }
1457 run_test 51 "special situations: split htree with empty entry =="
1458
1459 test_52a() {
1460         [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
1461         mkdir -p $DIR/d52a
1462         touch $DIR/d52a/foo
1463         chattr =a $DIR/d52a/foo || error
1464         echo bar >> $DIR/d52a/foo || error
1465         cp /etc/hosts $DIR/d52a/foo && error
1466         rm -f $DIR/d52a/foo 2>/dev/null && error
1467         link $DIR/d52a/foo $DIR/d52a/foo_link 2>/dev/null && error
1468         echo foo >> $DIR/d52a/foo || error
1469         mrename $DIR/d52a/foo $DIR/d52a/foo_ren && error
1470         lsattr $DIR/d52a/foo | egrep -q "^-+a-+ $DIR/d52a/foo" || error
1471         chattr -a $DIR/d52a/foo || error
1472
1473         rm -fr $DIR/d52a || error
1474 }
1475 run_test 52a "append-only flag test (should return errors) ====="
1476
1477 test_52b() {
1478         [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
1479         mkdir -p $DIR/d52b
1480         touch $DIR/d52b/foo
1481         chattr =i $DIR/d52b/foo || error
1482         cat test > $DIR/d52b/foo && error
1483         cp /etc/hosts $DIR/d52b/foo && error
1484         rm -f $DIR/d52b/foo 2>/dev/null && error
1485         link $DIR/d52b/foo $DIR/d52b/foo_link 2>/dev/null && error
1486         echo foo >> $DIR/d52b/foo && error
1487         mrename $DIR/d52b/foo $DIR/d52b/foo_ren && error
1488         [ -f $DIR/d52b/foo ] || error
1489         [ -f $DIR/d52b/foo_ren ] && error
1490         lsattr $DIR/d52b/foo | egrep -q "^-+i-+ $DIR/d52b/foo" || error
1491         chattr -i $DIR/d52b/foo || error
1492
1493         rm -fr $DIR/d52b || error
1494 }
1495 run_test 52b "immutable flag test (should return errors) ======="
1496
1497 test_53() {
1498         for i in /proc/fs/lustre/osc/OSC*mds1 ; do
1499                 ostname=`echo $i | cut -d _ -f 3-4 | sed -e s/_mds1//`
1500                 ost_last=`cat /proc/fs/lustre/obdfilter/$ostname/last_id`
1501                 mds_last=`cat $i/prealloc_last_id`
1502                 echo "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
1503                 if [ $ost_last != $mds_last ]; then
1504                     error "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
1505                 fi
1506         done
1507 }
1508 run_test 53 "verify that MDS and OSTs agree on pre-creation ===="
1509
1510 test_54() {
1511         $SOCKETSERVER $DIR/socket &
1512         sleep 1
1513         $SOCKETCLIENT $DIR/socket || error
1514         $MUNLINK $DIR/socket
1515 }
1516 run_test 54 "unix damain socket test ==========================="
1517
1518 test_59() {
1519         echo "touch 130 files"
1520         for i in `seq 1 130` ; do
1521                 touch $DIR/59-$i
1522         done
1523         echo "rm 130 files"
1524         for i in `seq 1 130` ; do
1525                 rm -f $DIR/59-$i
1526         done
1527         sync
1528         sleep 2
1529         # wait for commitment of removal
1530 }
1531 run_test 59 "verify cancellation of llog records async ========="
1532
1533 test_60() {
1534         echo 60 "llog tests run from kernel mode"
1535         sh run-llog.sh
1536 }
1537 run_test 60 "llog sanity tests run from kernel module =========="
1538
1539 test_61() {
1540         f="$DIR/f61"
1541         dd if=/dev/zero of=$f bs=`page_size` count=1
1542         cancel_lru_locks OSC
1543         multiop $f OSMWUc || error
1544         sync
1545 }
1546 run_test 61 "mmap() writes don't make sync hang =========="
1547
1548 # bug 2330 - insufficient obd_match error checking causes LBUG
1549 test_62() {
1550         f="$DIR/f62"
1551         echo foo > $f
1552         cancel_lru_locks OSC
1553         echo 0x405 > /proc/sys/lustre/fail_loc
1554         cat $f && error # expect -EIO
1555         multiop $f Owc && error
1556         echo 0 > /proc/sys/lustre/fail_loc
1557 }
1558 run_test 62 "verify obd_match failure doesn't LBUG (should -EIO)"
1559
1560 # bug 2319 - osic_wait() interrupted causes crash because of invalid waitq.
1561 test_63() {
1562         MAX_DIRTY_MB=`cat /proc/fs/lustre/osc/*/max_dirty_mb | head -1`
1563         for i in /proc/fs/lustre/osc/*/max_dirty_mb ; do
1564                 echo 0 > $i
1565         done
1566         for i in `seq 10` ; do
1567                 dd if=/dev/zero of=$DIR/f63 bs=8k &
1568                 sleep 5
1569                 kill $!
1570                 sleep 1
1571         done
1572
1573         for i in /proc/fs/lustre/osc/*/max_dirty_mb ; do
1574                 echo $MAX_DIRTY_MB > $i
1575         done
1576         true
1577 }
1578 run_test 63 "Verify osic_wait interruption does not crash ======"
1579
1580 # on the LLNL clusters, runas will still pick up root's $TMP settings,
1581 # which will not be writable for the runas user, and then you get a CVS
1582 # error message with a corrupt path string (CVS bug) and panic.
1583 # We're not using much space, so just stick it in /tmp, which is safe.
1584 OLDTMPDIR=$TMPDIR
1585 OLDTMP=$TMP
1586 TMPDIR=/tmp
1587 TMP=/tmp
1588 OLDHOME=$HOME
1589 [ $RUNAS_ID -ne $UID ] && HOME=/tmp
1590
1591 test_99a() {
1592         mkdir -p $DIR/d99cvsroot
1593         chown $RUNAS_ID $DIR/d99cvsroot
1594         $RUNAS cvs -d $DIR/d99cvsroot init || error
1595 }
1596 run_test 99a "cvs init ========================================="
1597
1598 test_99b() {
1599         [ ! -d $DIR/d99cvsroot ] && run_one 99a
1600         cd /etc/init.d
1601         $RUNAS cvs -d $DIR/d99cvsroot import -m "nomesg" d99reposname vtag rtag
1602 }
1603 run_test 99b "cvs import ======================================="
1604
1605 test_99c() {
1606         [ ! -d $DIR/d99cvsroot ] && run_one 99b
1607         cd $DIR
1608         mkdir -p $DIR/d99reposname
1609         chown $RUNAS_ID $DIR/d99reposname
1610         $RUNAS cvs -d $DIR/d99cvsroot co d99reposname
1611 }
1612 run_test 99c "cvs checkout ====================================="
1613
1614 test_99d() {
1615         [ ! -d $DIR/d99cvsroot ] && run_one 99c
1616         cd $DIR/d99reposname
1617         $RUNAS touch foo99
1618         $RUNAS cvs add -m 'addmsg' foo99
1619 }
1620 run_test 99d "cvs add =========================================="
1621
1622 test_99e() {
1623         [ ! -d $DIR/d99cvsroot ] && run_one 99c
1624         cd $DIR/d99reposname
1625         $RUNAS cvs update
1626 }
1627 run_test 99e "cvs update ======================================="
1628
1629 test_99f() {
1630         [ ! -d $DIR/d99cvsroot ] && run_one 99d
1631         cd $DIR/d99reposname
1632         $RUNAS cvs commit -m 'nomsg' foo99
1633 }
1634 run_test 99f "cvs commit ======================================="
1635
1636 TMPDIR=$OLDTMPDIR
1637 TMP=$OLDTMP
1638 HOME=$OLDHOME
1639
1640 log "cleanup: ======================================================"
1641 if [ "`mount | grep ^$NAME`" ]; then
1642         rm -rf $DIR/[Rdfs][1-9]*
1643         if [ "$I_MOUNTED" = "yes" ]; then
1644                 sh llmountcleanup.sh || error
1645         fi
1646 fi
1647
1648 echo '=========================== finished ==============================='
1649 [ -f "$SANITYLOG" ] && cat $SANITYLOG && exit 1 || true